#include "tricks.h"
#include "image.h"

#include <conio.h>
#include <stdio.h>

struct facep
{
   float x,y,z;
   float px,py;
   
   byte col;
   int Z;
};

// ********

facep kubp[8];
facep rotp[8];
int   kubf[6][4];

int startx[200];
int endx[200];

byte startcol[200];
byte endcol[200];

int startz[200];
int endz[200];

int y_tab[200];

// ********

void initpoint( int point, float x, float y, float z);
void initface ( int face, int a, int b, int c, int d);

void initall();

void rotate();
void project();

void polydraw();
void Poly( int Face );
void polyfix( int p1, int p2 );

byte buffer[64000];
int zbuf[64000];
Image back( "zbufback" );      // background

// **********

int main()
{
   SetMCGA();

   initall();

   do
   {
      memset( zbuf, 0, 64000*sizeof(int));
      back.Get( buffer );

      rotate();
      project();
      polydraw();
//      WaitRetrace();
      memcpy( vga, buffer, 64000);
   } while ( !kbhit() );

   getch();

   SetText();

   return 0;
}


// ************ DRAW ******************************************

void polyfix( int p1, int p2)
{
   int y1 = rotp[p1].py;
   int y2 = rotp[p2].py;

   if( y2 < y1 )
   {
      swap( y1,y2 );
      swap( p1,p2 );
   }

   int x1 = rotp[p1].px;
   int x2 = rotp[p2].px;

   byte col1 = rotp[p1].col;
   byte col2 = rotp[p2].col;

   int z1 = rotp[p1].Z;
   int z2 = rotp[p2].Z;

   if( y2 == y1 )
   {
      startx[y1] = x1;
      endx  [y1] = x2;

      startcol[y1] = col1;
      endcol[y1] = col2;

      startz[y1] = z1;
      endz[y1] = z2;
   }
   else
   {
      int X, Y, Step, col, colstep, z, zstep;

      int dy = y2-y1;

      if( dy == 0) dy++;

      X = x1 << 16;
      col = col1 << 16;
      z = z1 << 16;

      Step    = ((x2-x1) << 16) / dy;
      colstep = ((col2-col1) << 16) / dy;
      zstep   = ((z2-z1) << 16) / dy;

      X += Step;
      y1++;
      col += colstep;
      z += zstep;

      for( Y = y1; Y <= y2; Y++)
      {
         if(( Y>=0 )&&( Y<200 ))
         {
            if( startx[ Y ] == -1)
            {
               startx[ Y ]   = (X >> 16);
               startcol[ Y ] = (col >> 16); 
               startz[ Y ]   = (z >> 16);
            }
            else
            {
               if( (X >> 16) < 320 )
               {
                  endx[ Y ]   = (X >> 16);
                  endcol[ Y ] = (col >> 16 );
                  endz[ Y ]   = (z >> 16);
               }
               else
               {
                  endx[ Y ]   = 319;
                  endcol[ Y ] = (col >> 16 );
                  endz[ Y ]   = (z >> 16);
               }
            }
         }

         X += Step;
         col += colstep;
         z += zstep;
      }
   }
}

void polydraw()
{
   for( int i=0; i<6; i++ )
   {
      int p0 = kubf[i][0];
      int p1 = kubf[i][1];
      int p2 = kubf[i][2];
      int p3 = kubf[i][3];

      float norm =   ((rotp[p3].y - rotp[p0].y) * (rotp[p1].x - rotp[p0].x))
                   - ((rotp[p1].y - rotp[p0].y) * (rotp[p3].x - rotp[p0].x));

      if( norm < -0.2 )
         Poly( i );
   }
}

void Poly( int F )
{
   for( int i=0; i<200; i++)
      startx[i] = endx[i] = -1;

   polyfix( kubf[F][0],kubf[F][1] );
   polyfix( kubf[F][1],kubf[F][2] );
   polyfix( kubf[F][2],kubf[F][3] );
   polyfix( kubf[F][3],kubf[F][0] );

   for( i=0; i<200; i++ )
   {
      if( startx[i] != -1 )
      {         
         if( endx[i] == -1)
         {
//            if( zbuf[ y_tab[i]+startx[i] ] > startz[i] )
//               buffer[ y_tab[i]+startx[i] ] = startcol[i];
         }
         else
         {
            if( startx[i] > endx[i] )
            {
               swap( startx[i], endx[i]);
               swap( startcol[i], endcol[i]);
               swap( startz[i], endz[i]);
            }
            else if( startx[i] == endx[i] )
               endx[i]++;
           

            int colorstep = ((endcol[i]-startcol[i] + 1) << 16) / (endx[i]-startx[i]+1);
            int color = startcol[i] << 16;

            int zstep = ((endz[i]-startz[i]) << 16) / (endx[i]-startx[i]);
            int z = startz[i] << 16;

            for( int x=startx[i]; x<=endx[i]; x++)
            {
               if( zbuf[y_tab[i]+x] > z )
                  buffer[ y_tab[i]+x ] = (byte) (color >> 16);
   
               color += colorstep;
               z     += zstep;
            }
         }
      }
   }
}




// ************ PROJECT ***************************************

void rotate()
{
   static double Xangle = 0;
   static double Yangle = 0;
   static double Zangle = 0;

   Xangle += 0.022;
   Yangle += 0.02;
   Zangle += 0.025;
	
   float sinX = sin(Xangle);
   float cosX = cos(Xangle);

   float sinY = sin(Yangle);
   float cosY = cos(Yangle);

   float sinZ = sin(Zangle);
   float cosZ = cos(Zangle);

   float temp;

   for( int i=0; i<8; i++)       
	{
      rotp[i].y = kubp[i].y * cosZ - kubp[i].x * sinZ;
      rotp[i].x = kubp[i].x * cosZ + kubp[i].y * sinZ;

      rotp[i].z = kubp[i].z * cosY - rotp[i].x * sinY;
      rotp[i].x = rotp[i].x * cosY + kubp[i].z * sinY;

      temp      = rotp[i].y * cosX + rotp[i].z * sinX;
      rotp[i].z = rotp[i].z * cosX - rotp[i].y * sinX;
      rotp[i].y = temp;

      rotp[i].col = (64 - (byte) (((rotp[i].z)+1.8) * 32)) + 192;
      if( rotp[i].col < 192 ) rotp[i].col = 192;
	}
}

void project()
{
   static double z = 0;
   z += 0.01;

   float zd = sin(z) * 1.2;

   for( int i=0; i<8; i++ )
   {
      rotp[i].px = (( rotp[i].x / (rotp[i].z + zd + 15)) * 700) + 160;      
      rotp[i].py = (( rotp[i].y / (rotp[i].z + zd + 15)) * 600) + 100;      

      rotp[i].Z = int ((rotp[i].z + zd) * 10000);
   }
}

// ************* INITS *****************************************

void initall()
{
   for( int i=0; i<200; i++ )
      y_tab[i] = i*320;

   back.ShowPal();

   for( i=192; i<256; i++)
      Pal( i,0,0,i-192 );

   initpoint( 0,  1,  1, 1 );
   initpoint( 1,  1, -1, 1 );
   initpoint( 2, -1, -1, 1 );
   initpoint( 3, -1,  1, 1 );

   initpoint( 4,  1,  1, -1 );
   initpoint( 5,  1, -1, -1 );
   initpoint( 6, -1, -1, -1 );
   initpoint( 7, -1,  1, -1 );

   initface( 0, 0,3,2,1);
   initface( 1, 4,0,1,5);
   initface( 2, 7,4,5,6);
   initface( 3, 3,7,6,2);
   initface( 4, 7,3,0,4);
   initface( 5, 5,1,2,6);

   kubp[0].col = 0;
   kubp[1].col = 15;
   kubp[2].col = 63;
   kubp[3].col = 32;
   kubp[4].col = 63;
   kubp[5].col = 32;
   kubp[6].col = 0;
   kubp[7].col = 15;
}

void initpoint( int point, float x, float y, float z)
{
   kubp[point].x = x;
   kubp[point].y = y;
   kubp[point].z = z;
}

void initface ( int face, int a, int b, int c, int d)
{
   kubf[face][0] = a;
   kubf[face][1] = b;
   kubf[face][2] = c;
   kubf[face][3] = d;
}
   
